
function demo_I
% demo sulla soluzione di f(x)=0 mediante il metodo di Steffensen.

% dati
f=@(x) exp(x)-2+x;
toll=10^(-6);
maxit=1000;

% valore iniziale
x0=input('\n \t * x0: ');

% metodo di Steffensen
[x,fx,wr,flag]=metodo_steffensen(f,x0,toll,maxit);

% stampa dati su file
fid=fopen('risultati.txt','w');
N=length(x);
fprintf(fid,'\n \t numero iterazioni piu'' uno: %4.0f',N);
fprintf(fid,'\n \t soluzione                  : %1.15e',x(end));
fprintf(fid,'\n \t step pesato                : %1.15e',wr(end));
fclose(fid);

semilogy(1:length(wr),wr,'ro');
hold on
title('Step del metodo di Steffensen');
xlabel('Indice iterazione')
ylabel('Step')
print('steffensen.pdf','-dpdf');
hold off




